;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

NMDAYSTATE STRUCT
    nmhdr       NMHDR       <>
    stStart     SYSTEMTIME  <>
    cDayState   DWORD       ?
    prgDayState DWORD       ?
NMDAYSTATE ENDS

MONTHDAYSTATE typedef DWORD

;==============================================================================
    .data
      hInstance dd 0
      hwndMC    dd 0

      ;-------------------------------------------------------------
      ; At its default size the calendar only displays 1 full month
      ; and 2 partial months, so our MONTHDAYSTATE array only needs
      ; 3 elements, here initialized so the days 1 and 28 will be
      ; displayed in bold.
      ;-------------------------------------------------------------

      mds       dd 3 dup(0001000000000000000000000000001b)
                        ;1098765432109876543210987654321

      icce      INITCOMMONCONTROLSEX <>

      systime   SYSTEMTIME 2 dup(<>)

    .code
;==============================================================================

DlgProc proc uses ebx hwndDlg:dword, uMsg:dword, wParam:dword, lParam:dword

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hwndDlg, 101
        mov hwndMC, eax

        invoke SendMessage, hwndMC, MCM_GETMONTHRANGE,
                            GMR_DAYSTATE, ADDR systime
        print str$(eax),13,10

        movzx eax, systime.wMonth
        print str$(eax),13,10

        movzx eax, systime[sizeof SYSTEMTIME].wMonth
        print str$(eax),13,10

        ;---------------------------------------------------------
        ; This is not actually needed because our MCN_GETDAYSTATE
        ; notification handler will perform the same action.
        ;---------------------------------------------------------

        invoke SendMessage, hwndMC, MCM_SETDAYSTATE, 3, ADDR mds
        print str$(eax),13,10

      CASE WM_NOTIFY

        ;----------------------------------------
        ; At this point we know that lParam is a
        ; pointer to an NMHDR structure.
        ;----------------------------------------

        mov ebx, lParam

        ;-------------------------------------------------------
        ; If the notification code in the NMHDR structure is
        ; MCN_GETDAYSTATE, then we know that lParam is actually
        ; a pointer to an NMDAYSTATE structure.
        ;-------------------------------------------------------

        .IF [ebx].NMHDR.code == MCN_GETDAYSTATE

          ;-----------------------------------------------------
          ; Display the starting month from the stStart member.
          ;-----------------------------------------------------

          movzx eax, [ebx].NMDAYSTATE.stStart.SYSTEMTIME.wMonth
          print str$(eax),13,10

          ;-------------------------------------------------------
          ; Set the number of elements in the MONTHDAYSTATE array
          ; and set the address of the array. This must be done
          ; each time the month changes.
          ;-------------------------------------------------------

          mov [ebx].NMDAYSTATE.cDayState, 3
          mov [ebx].NMDAYSTATE.prgDayState, OFFSET mds

        .ENDIF

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, 0

    ENDSW

    xor eax, eax
    ret

DlgProc endp

;==============================================================================
start:
;==============================================================================

    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX
    mov icce.dwICC, ICC_DATE_CLASSES
    invoke InitCommonControlsEx, ADDR icce

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "Test", \
           "MS Sans Serif",8, \
           WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
           1,0,0,120,110,1024

    DlgMonthCal MCS_DAYSTATE or MCS_NOTODAYCIRCLE,0,0,118,100,101

    CallModalDialog hInstance,0,DlgProc,NULL

    exit
;==============================================================================
end start
